| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
FileDownloader Class Reference
Network

>Provides file download facility More...

`#include <odnetworkaccess.h>`

Inheritance diagram for FileDownloader:
[legend]

## Public Member Functions
| FileDownloader (const BufferStringSet &urls, const BufferStringSet &outputpaths)
| FileDownloader (const char *url)
| FileDownloader (const char *url, DataBuffer &)
| ~FileDownloader ()
od_int64 | getDownloadSize ()
int | nextStep () override
od_int64 | nrDone () const override
od_int64 | totalNr () const override
uiString | uiMessage () const override
uiString | uiNrDoneText () const override
Public Member Functions inherited from SequentialTask
| SequentialTask (const char *nm=nullptr)
virtual | ~SequentialTask ()
virtual int | doStep ()
bool | execute () override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
Task & | operator= (const Task &)=delete
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Protected Member Functions
int | errorOccured ()
void | setSaveAsPaths (const BufferStringSet &, const char *)
bool | writeData ()
bool | writeDataToBuffer (const char *buffer, int size)
bool | writeDataToFile (const char *buffer, int size)
Protected Member Functions inherited from SequentialTask
virtual bool | doFinish (bool success, od_ostream *=nullptr)
virtual bool | doPrepare (od_ostream *=nullptr)
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
DataBuffer * | databuffer_ = nullptr
bool | initneeded_ = true
uiString | msg_
od_int64 | nrdone_ = 0
int | nrfilesdownloaded_ = 0
RefMan< Network::HttpRequestProcess > | odnr_
od_ostream * | osd_ = nullptr
BufferStringSet | saveaspaths_
od_int64 | totalnr_ = 0
BufferStringSet | urls_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from SequentialTask
static int | ErrorOccurred ()
static int | Finished ()
static int | MoreToDo ()
static int | WarningAvailable ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Detailed Description

>Provides file download facility

<>

## Constructor & Destructor Documentation

## ◆ FileDownloader() [1/3]

FileDownloader::FileDownloader | ( | const char * | url | ) |

## ◆ FileDownloader() [2/3]

FileDownloader::FileDownloader | ( | const char * | url,
|  | DataBuffer & | )

## ◆ FileDownloader() [3/3]

FileDownloader::FileDownloader | ( | const BufferStringSet & | urls,
|  | const BufferStringSet & | outputpaths )

## ◆ ~FileDownloader()

FileDownloader::~FileDownloader | ( |  | ) |

## Member Function Documentation

## ◆ errorOccured()

int FileDownloader::errorOccured | ( |  | ) |
| protected

## ◆ getDownloadSize()

od_int64 FileDownloader::getDownloadSize | ( |  | ) |

## ◆ nextStep()

int FileDownloader::nextStep | ( |  | ) |
| override virtual

Return values

  MoreToDo() | Not finished. Call me again.
  Finished() | Nothing more to do.
  ErrorOccurred() | Something went wrong.

Note
  if function returns a value greater than cMoreToDo(), it should be interpreted as cMoreToDo().

Implements SequentialTask.

## ◆ nrDone()

od_int64 FileDownloader::nrDone | ( |  | ) | const
| override virtual

Note
  nrDone is only used for displaying progress and will be compared to totalNr to show user how large part of the task that is finished.

Reimplemented from Task.

## ◆ setSaveAsPaths()

void FileDownloader::setSaveAsPaths | ( | const BufferStringSet & | ,
|  | const char * | )
| protected

## ◆ totalNr()

od_int64 FileDownloader::totalNr | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiMessage()

uiString FileDownloader::uiMessage | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiNrDoneText()

uiString FileDownloader::uiNrDoneText | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ writeData()

bool FileDownloader::writeData | ( |  | ) |
| protected

## ◆ writeDataToBuffer()

bool FileDownloader::writeDataToBuffer | ( | const char * | buffer,
|  | int | size )
| protected

## ◆ writeDataToFile()

bool FileDownloader::writeDataToFile | ( | const char * | buffer,
|  | int | size )
| protected

## Member Data Documentation

## ◆ databuffer_

DataBuffer* FileDownloader::databuffer_ = nullptr
| protected

## ◆ initneeded_

bool FileDownloader::initneeded_ = true
| protected

## ◆ msg_

uiString FileDownloader::msg_
| protected

## ◆ nrdone_

od_int64 FileDownloader::nrdone_ = 0
| protected

## ◆ nrfilesdownloaded_

int FileDownloader::nrfilesdownloaded_ = 0
| protected

## ◆ odnr_

RefMan<Network::HttpRequestProcess> FileDownloader::odnr_
| protected

## ◆ osd_

od_ostream* FileDownloader::osd_ = nullptr
| protected

## ◆ saveaspaths_

BufferStringSet FileDownloader::saveaspaths_
| protected

## ◆ totalnr_

od_int64 FileDownloader::totalnr_ = 0
| protected

## ◆ urls_

BufferStringSet FileDownloader::urls_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025